/*
  FCrypt - A censorship-resistant cryptosystem
  Copyright (C) 2012  Fabio J. Gonzalez <gonzalfj@ymail.com>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* The higher this value, there will be less
   communication between the driver and this
   program, but had used more memory space.
   The bigger, faster linear access,
   and a slower random access. */
#define ENCRYPTED_BLOCK_SIZE 1024

#ifndef BLOCK_SIZE
#define BLOCK_SIZE ENCRYPTED_BLOCK_SIZE
#endif

/* The request for any action that the driver
   makes the program in User mode. */
typedef struct
{
  enum {
    REQUEST_SEEK,
    REQUEST_READ,
    REQUEST_WRITE
  } type;
  unsigned long long pos;
  unsigned long long len;
} Request;

/* Response that the program returns 
   to the driver. */
typedef struct
{
  unsigned long long pos;
  unsigned long long len;
  int ok;
} Response;
